// client.exe
using System;
using System.Configuration;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels.Tcp;

class Test
{
    static void Main()
    {
        RemotingConfiguration.Configure("client.exe.config");

        TestLocalCase();
        TestRemoteCase();
    }

    static void TestLocalCase()
    {
        IFoo f = (IFoo)Activator.CreateInstance("server", "Foo").Unwrap();

        Console.WriteLine("[local] Calling IFoo.WorkSlowly...");
        f.WorkSlowly(2, 4);
        Console.WriteLine("[local] Done calling IFoo.WorkSlowly...");
    }

    static void TestRemoteCase()
    {
        IFoo f = (IFoo)
            RemotingServices.Connect( typeof(IFoo),
                                      ConfigurationSettings.AppSettings["FooObjectURI"] );
        Console.WriteLine("[remote] Calling IFoo.WorkSlowly...");
        f.WorkSlowly(2, 4);
        Console.WriteLine("[remote] Done calling IFoo.WorkSlowly...");
    }

}
